summaryrefslogtreecommitdiffstats
path: root/development/Catch2
diff options
context:
space:
mode:
author Steven Voges <svoges.sbo@gmail.com>2023-03-31 17:10:37 +0100
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2023-04-01 09:14:16 +0700
commit2000566092d3ef87d196e2ff9257b47f1a4222fa (patch)
tree585ae8abd5830cc360044bf63a5e9330e9029721 /development/Catch2
parentcd839bd4719dc681f9b4ad6f3550f41e1c3ef17d (diff)
downloadslackbuilds-2000566092d3ef87d196e2ff9257b47f1a4222fa.tar.gz
slackbuilds-2000566092d3ef87d196e2ff9257b47f1a4222fa.tar.xz
development/Catch2: Added (Unit testing framework for C++)
Signed-off-by: bedlam <dave@slackbuilds.org> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'development/Catch2')
-rw-r--r--development/Catch2/Catch2.SlackBuild111
-rw-r--r--development/Catch2/Catch2.info10
-rw-r--r--development/Catch2/README10
-rw-r--r--development/Catch2/slack-desc19
4 files changed, 150 insertions, 0 deletions
diff --git a/development/Catch2/Catch2.SlackBuild b/development/Catch2/Catch2.SlackBuild
new file mode 100644
index 0000000000..2348120a22
--- /dev/null
+++ b/development/Catch2/Catch2.SlackBuild
@@ -0,0 +1,111 @@
+#!/bin/bash
+
+# Slackware build script for Catch2
+
+# Copyright 2023 Steven Voges <Oregon, USA>
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=Catch2
+VERSION=${VERSION:-3.3.2}
+DOCS=${DOCS:-OFF}
+EXTRAS=${EXTRAS:-ON}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DCATCH_INSTALL_DOCS=$DOCS \
+ -DCATCH_INSTALL_EXTRAS=$EXTRAS \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ docs/* *.md LICENSE.txt \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+if [ "$DOCS" = "ON" ]; then
+ mv $PKG/usr/share/doc/$PRGNAM/* $PKG/usr/doc/$PRGNAM-$VERSION
+ rm -rf $PKG/usr/share/doc
+fi
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/development/Catch2/Catch2.info b/development/Catch2/Catch2.info
new file mode 100644
index 0000000000..368e1b5d85
--- /dev/null
+++ b/development/Catch2/Catch2.info
@@ -0,0 +1,10 @@
+PRGNAM="Catch2"
+VERSION="3.3.2"
+HOMEPAGE="https://github.com/catchorg/Catch2"
+DOWNLOAD="https://github.com/catchorg/Catch2/archive/v3.3.2/Catch2-3.3.2.tar.gz"
+MD5SUM="6a15aa49dbdee13f279b73cab16ae203"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Steven Voges"
+EMAIL="svoges.sbo@gmail.com"
diff --git a/development/Catch2/README b/development/Catch2/README
new file mode 100644
index 0000000000..71a3b7bc43
--- /dev/null
+++ b/development/Catch2/README
@@ -0,0 +1,10 @@
+Catch2 is mainly a unit testing framework for C++, but it also
+provides basic micro-benchmarking features, and simple BDD macros.
+
+Catch2's main advantage is that using it is both simple and natural.
+Test names do not have to be valid identifiers, assertions look like
+normal C++ boolean expressions, and sections provide a nice and local
+way to share set-up and tear-down code in tests.
+
+Catch2 builds the v3 branch of Catch2.
+This package conflicts with Catch.
diff --git a/development/Catch2/slack-desc b/development/Catch2/slack-desc
new file mode 100644
index 0000000000..b6e7133763
--- /dev/null
+++ b/development/Catch2/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+Catch2: Catch2 (Unit testing framework for C++)
+Catch2:
+Catch2: A modern, C++-native, test framework for unit-tests, TDD and BDD -
+Catch2: using C++14, C++17 and later.
+Catch2:
+Catch2: Homepage: https://github.com/catchorg/Catch2
+Catch2:
+Catch2:
+Catch2:
+Catch2:
+Catch2: